<?php
// $Id:
// 
//roles
define('RID_TRADER', 3);
define('RID_COMMITTEE', 4);
define('RID_ACCOUNTANT', 5);
define('RID_LOCAL_ADMIN', 6);
define('RID_SYSTEM', 7);
define('NODE_BROADCAST_FLAG', 'sticky');


/**
 * Implementation of hook_form_alter().
 *
 * Allows the profile to alter the site-configuration form. This is
 * called through custom invocation, so $form_state is not populated.
 */
function cforge_form_alter(&$form, $form_state, $form_id) {
  if ($form_id == 'install_configure_form') {
    $form['site_information']['site_name']['#default_value'] = $_SERVER['SERVER_NAME'];

    if (strpos($_SERVER["HTTP_HOST"], 'ommunityforge.net')) {
      $form['admin_account']['account']['name']['#default_value'] = 'admin';
      $form['admin_account']['account']['name']['#type'] = 'hidden';
      $form['admin_account']['account']['mail']['#default_value'] = 'tim@communityforge.net';
      $form['admin_account']['account']['mail']['#type'] = 'hidden';
      $form['server_settings']['date_default_timezone']['#default_value'] = 'CET';
    }
  }
}


/*
 * implements hook_user_login
 */
function cforge_user_login(&$edit, &$account, $category = NULL) {
  if (substr($_SERVER['SCRIPT_NAME'], 9) == 'index.php') {
    drupal_goto('news');
  }
}

/*
 * implements hook_user_form
 */
function cforge_user_form(&$edit, &$account, $category = NULL) {debug(func_get_args());
  //this system doesn't show usernames to anyone, but uses sky_seldulac_username() instead
  $form['pass']['#access'] == FALSE;
  //prevent non-admin from editing account 1 login
  if ($account->uid == 1 && $GLOBALS['user']->uid > 1) {
    $form['name']['#access'] = FALSE;
  }
}

function cf_vids() {
  global $language;
  switch ($language->language) {
    case 'fr':
      return array(
        'sel_promo' => array(
          'url' => 'http://www.youtube.com/embed/fwy2sojt3ZM',
          'title' => '',
          'pages' => "home\nLETS\ncommit"
        ),
        'decouvrir' => array(
          'url' => 'http://www.youtube.com/embed/videoseries?list=PLBA6ED7FC6AFC4A2A&amp;hl=en_US',
          'title' => 'Video découvrir le site',
          'pages' => "news/recent\nuser/*\noffers\nwants"
        )
      );
    case 'es':
      return array(
        'cf_training' => array(
          'url' => 'http://www.youtube.com/embed/pEdk1gct0Iw?list=PL2C2A689416705667',
          'title' => 'Darse de alta en la Central de Talentos',
          'pages' => "news*\nuser/*\noffer*\nwant*\nexchange*"
        )
      );
    default:
      return array(
        'nitin' =>array(
          'url' => 'http://www.youtube.com/embed/YvegNqKcQ-g',
          'title' => 'Mutual Credit',
          'pages' => "home\nLETS\ncommit"
        )
      );
  }
}

/*
 * implements hook_block_info
 */
function cforge_block_info() {
  foreach (cf_vids() as $delta => $data) {
    $blocks[$delta] = array(
      'info' => $delta,
      'visibility' => 0,
      'pages' => $data['pages'],
      'status' => 1,
      'weight' => 10,
      'region' => 'sidebar_second'
    );
  }
  return $blocks;
}

/*
 * implements hook_block_view
 * put the menu blocks in place
 */
function cforge_block_view($delta) {
  $vids = cf_vids();
  return array(
    'title' => isset($vids[$delta]['title']) ? $vids[$delta]['title'] : '<none>',
    'content' => '<iframe width="320" height="240" src="'.$vids[$delta]['url'].'" frameborder="0" allowfullscreen></iframe>'
  );
}

/*
 * implements hook_block_view_alter
 * Change the title of the user block
 */
function cforge_block_view_alter(&$block) {
  if (isset($block['subject']) && $block['subject'] == t('User menu')) {
    $block['subject'] = format_username($GLOBALS['user']);
  }
}


/*
 * implements hook_block_info_alter
 * put the menu blocks in place in theme 
 */
function cforge_block_info_alter(&$items) {
  $example = current(current($items));
  if ($example['theme'] != 'sky_seldulac') return;
  /*
  if (isset($items['comment'])) {
    $items['comment']['recent'] = array(
      'status' => 0,
      'weight' => 0,
      'region' => '',
      'custom' => 0,
      'visibility' => 0,
      'pages' => '',
      'title' => '',
      'cache' => 1,
    ) + $items['comment']['recent'];
  }
   */
  if (isset($items['menu'])) {
    /*
    $items['menu']['manage'] = array(
      'status' => 1,
      'weight' => 8,
      'region' => 'sidebar_second',
      'visibility' => 0,
      'pages' => '',
      'title' => t('Manage'),
      'cache' => -1,
    ) + $items['menu']['manage'];
     *
     */
    $items['menu']['setup'] = array(
      'status' => 1,
      'weight' => 7,
      'region' => 'sidebar_second',
      'custom' => 0,  //TODO not sure if this custom field is necessary
      'visibility' => 0,
      'pages' => '',
      'title' => '',
      'cache' => -1,
      'roles' => array(RID_LOCAL_ADMIN)
    ) + $items['menu']['setup'];
    if (isset($items['menu']['secondary-links']) && $items['menu']['secondary-links']['theme'] == 'sky_seldulac') {
      $items['menu']['secondary-links'] = array(
        'status' => 1,
        'weight' => 2,
        'region' => 'contenttop',
        'custom' => 0,
        'visibility' => 0,
        'pages' => '',
        'title' => '<none>',
        'cache' => -1,
      ) + $items['menu']['secondary-links'];
    }
  }
  if (isset($items['search']) && $items['search']['form']['theme'] == 'sky_seldulac') {
    $items['search']['form'] = array(
      'status' => 1,
      'weight' => 1,
      'region' => 'contenttop',
      'visibility' => 0,
      'pages' => '',
      'title' => '<none>',
      'cache' => -1,
    ) + $items['search']['form'];
  }
  $items['system']['help'] = array(
    'status' => 1,
    'weight' => -1,
    'region' => 'content',
    'custom' => 0,
    'visibility' => 0,
    'pages' => '',
    'title' => '',
    'cache' => -1,
  ) + $items['system']['help'];
  $items['system']['main'] = array(
    'status' => 1,
    'weight' => 0,
    'region' => 'content',
    'custom' => 0,
    'visibility' => 0,
    'pages' => '',
    'title' => '',
    'cache' => -1,
  ) + $items['system']['main'];
  $items['user']['login'] = array(
    'status' => 1,
    'weight' => 6,
    'region' => 'sidebar_second',
    'custom' => 0,
    'visibility' => 0,
    'pages' => '',
    'title' => '',
    'cache' => -1,
  ) + $items['user']['login'];
  $items['system']['user-menu'] = array(
    'status' => 1,
    'weight' => -10,
    'region' => 'sidebar_second',
    'custom' => 0,
    'visibility' => 0,
    'pages' => '',
    'cache' => -1,
  ) + $items['system']['user-menu'];
  $items['user']['new'] = array(
    'status' => 1,
    'weight' => 7,
    'region' => 'sidebar_first',
    'custom' => 0,
    'visibility' => 1,
    'pages' => "home\nnews/recent\nmembers",
    'title' => '',
    'cache' => -1,
    ) + $items['user']['new'];
  $items['user']['login'] = array(
    'status' => 1,
    'weight' => 6,
    'region' => 'sidebar_second',
    'custom' => 0,
    'visibility' => 0,
    'pages' => '',
    'title' => '',
    'cache' => -1,
  ) + $items['user']['login'];
}


/*
 * Implements views hook_views_api
 */
function cforge_views_api() {
  return array(
    'api' => 3,
    'path' => drupal_get_path('module', 'cforge'),
  );
}
/*
 * implements hook_cron
 */
function cforge_cron() {
  db_query("DELETE FROM {sessions} WHERE uid = 0 AND timestamp < '-1 day'");
  db_query("DELETE FROM {cache_form} WHERE expire != :cache AND expire < :time", 
    array(':cache' => CACHE_PERMANENT, ':time' => REQUEST_TIME)
  );
}

/**
 * implements hook_init().
 */
function cforge_init() {
  drupal_add_css(drupal_get_path('module', 'cforge').'/cforge.css');
  // saves adding the disable password strength module
  if (arg(0) === 'user' || (arg(2) == 'user' && arg(3) == 'create')) {
    drupal_add_js('Drupal.behaviors.password = function () {};', 'inline', 'footer');
  }
}

/**
 * implements hook_menu
 */
function cforge_menu() {
  $items['backup'] = array(
    'page callback' => 'backup_direct',
    'access arguments' => array('committee'),
    'type' => MENU_NORMAL_ITEM
  );
  return $items;
}


/**
 * implements hook_menu_alter
 */
function cforge_menu_alter(&$items) {
  //tweak the user tabs
  $items['user/%user/edit']['title'] = t('Account');
  $items['user/%user/contact']['weight'] = 5;
  $items['contact']['menu_name'] = 'secondary-links';
  $items['contact']['type'] = MENU_NORMAL_ITEM;
  $items['members']['menu_name'] = 'main-menu';
  //alter the access so the local admin can see some admin pages.
  $items['admin/config/system/site-information']['access arguments'] = array('local admin');
  //committee can re-arrange menu items but not add and remove them through the menu interface
  $items['admin/structure/menu/manage/%menu']['access arguments'] = array('committee');//d7 check menu_menu
  $items['admin/structure/menu/manage/%item/edit']['access arguments'] = array('committee');
  $items['admin/structure/menu/manage/%menu/list']['access arguments'] = array('committee');
  $items['admin/structure/menu/manage/%menu/edit']['access arguments'] = array('committee');
  $items['admin/structure/menu/manage/%menu/add'] ['access arguments'] = array('access administration pages');
  $items['admin/structure/menu/manage/%menu/delete']['access arguments']=array('access administration pages');
  $items['admin/content/node']['access arguments'] = array('committee');
  $items['admin/structure/taxonomy/%taxonomy_vocabulary_machine_name']['access arguments'] = array('committee');

  $items['user/autocomplete']['page callback'] = 'cforge_user_autocomplete';
  $items['user/autocomplete']['access arguments'] = array('transact');

  //move stuff to the setup menu
  $items['admin/config/system/site-information']['menu_name'] = 'setup';
  $items['admin/config/system/site-information']['description'] = t("Change basic site information, such as the site name, slogan, e-mail address, mission, front page and more.");
  $items['admin/config/people/accounts']['menu_name'] = 'setup';
  $items['admin/config/people/accounts']['title'] = t("member registration");
  $items['admin/config/people/accounts']['description'] = t("Compose the e-mail to be sent on welcoming user.");
  $items['admin/config/people/accounts']['access arguments'] =  array('committee');
  $items['admin/structure/contact']['title'] = t('contact form');
  $items['admin/structure/contact']['menu_name'] = 'setup';
  $items['admin/structure/contact']['description'] = t("Setup up site wide & member contacts.");
  $items['admin/structure/taxonomy']['menu_name'] = 'user-menu';
  $items['admin/structure/taxonomy']['title'] = t('categories');
  $items['admin/appearance/settings/sky_seldulac']['access callback'] = 'user_access';
  $items['admin/appearance/settings/sky_seldulac']['access arguments'] = array('local admin');

  //move stuff to the manage menu
  $items['admin/content']['menu_name'] = 'user-menu';
  $items['admin/content']['title'] = t('manage content');
  $items['admin/content']['weight'] = 0;
  $items['node/add']['menu_name'] = 'user-menu';
  $items['node/add']['title'] = t('create content');
  $items['node/add']['weight'] = 0;

  $items['admin/people']['menu_name'] = 'user-menu';
  $items['admin/people']['type'] = MENU_NORMAL_ITEM;
  $items['admin/people']['title'] = t('manage people');
  $items['admin/people']['description'] = t("List, add and modify users");
  $items['admin/people']['access arguments'] = array('committee');
  $items['admin/people']['weight'] = 0;
  if (module_exists('backup_migrate')) {
    $items[BACKUP_MIGRATE_MENU_PATH .'/restore']['menu_name'] = 'setup';
    $items[BACKUP_MIGRATE_MENU_PATH .'/restore']['access arguments'] = array('local admin');
    $items[BACKUP_MIGRATE_MENU_PATH .'/restore']['type'] = MENU_NORMAL_ITEM;
  }
  $items['user/logout']['weight'] = 50;
  //community tasks
  $items['community_tasks']['menu_name'] = 'main-menu';
}


//expand the node/add link
function ____cforge_menu_link_alter($items) {
//  debug($items);
}

/*
 * implementation of theme callback 'username'
 */
function cforge_username($vars) {
  $account = &$vars['account'];
  if (!$account->uid) return check_plain(variable_get('anonymous', t('Anonymous')));
  static $users = array();
  if (empty($users[$account->uid])) {
    //reload the user object if required fields are not present
    if (!$account->profile_firstname && !$account->profile_familyname) {
       $account = user_load($account->uid);
    }
    if (user_access('transact')) {
      //prepare the link, or not, and put in the static array
      if (user_access('access user profiles') && $GLOBALS['user']->uid <> $account->uid) {
        $users[$account->uid] = l($account->name, 'user/'. $account->uid, array('attributes' => array('title' => t('View member profile.'))));
      }
      else {
        $users[$account->uid] = $account->name;
      }
    }
    //in case user mustn't see names
    else {
      $users[$account->uid] = t("Member @uid", array("@uid" => $account->uid));
    }
  }
  return $users[$account->uid];
}
/*
 * implements hook_filter_info_alter
 * settings for the ckeditor
 */
function cforge_filter_info_alter(&$filters) {
  //debug($filters['filter_html']['default settings']);
  //$filters['filter_html']['default settings']['allowed_html'] = '<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>';
}

/*
 * implements hook_user_submit
 * implements a cforge version of username
 */
function cforge_user_submit(&$edit, &$account, $category = NULL) {
  if ($edit['profile_firstname'] && $edit['profile_familyname']) {
    $edit['name'] = _make_realname((object)$edit);
  }
}
function _make_realname($account) {
  if (empty($account->profile_firstname) || empty($account->profile_familyname)) {
    $account = user_load($account);
  }
  return $account->profile_firstname .' '. $account->profile_familyname;
}


function cforge_permission() {
  return array(
    'local admin' => array(
      'title' => t('Local admin'),
      'description' => t('Administer the site without breaking anything')
    ),
    'committee' => array(
      'title' => t('Committee'),
      'description' => t('Perform community maintenance tasks')
    )
  );
}


function cforge_node_view_alter(&$render_array, $view_mode) {
  $render_array['comments']['#weight'] = 19;
}

function cforge_form_user_profile_form_alter(&$form, &$form_state) {
  //responsibility field should only show on the edit forms of committee members
  if (!in_array('committee', $form['#user']->roles)) {
    unset($form['profile_responsibility']);
  }
  //hide role expiry for unneeded roles
  foreach (array(RID_COMMITTEE, RID_ACCOUNTANT, RID_LOCAL_ADMIN, RID_SYSTEM) as $rid) {
    $form["role_expire_$rid"]['#access'] = FALSE;
  }
  //hide the checkbox showing authenticated user
  $form['account']['roles'][2]['#access'] = FALSE;

  $form['account']['name']['#access'] = FALSE;
  //prevent editing of essential user 1 fields
  if (!user_access('committee')) {
    if ($GLOBALS['user']->uid != 1) {
      $form['account']['pass']['#access'] = FALSE;
      $form['account']['current_pass']['#access'] = FALSE;
      $form['account']['mail']['#access'] = FALSE;
    }
    $form['account']['status']['#access'] = FALSE;
    $form['account']['roles']['#access'] = FALSE;
  }

  //advanced_help
  $form['account']['name']['#description'] .= theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'name'));
  $form['account']['pass']['#description'] .= theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'pass'));
  $form['account']['mail']['#description'] .= theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'mail'));
  $form['account']['status']['#title'] .= theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'status'));
  $form['account']['roles']['#title'] .= theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'roles'));
  if (isset($form['limits_personal'])) {
    $form['limits_personal']['#description'] = theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'balance_limits'));
  }
  $form['picture']['picture_upload']['#title'] .= ' ('.t('No spaces in filenames!').')';
  $form['picture']['picture_upload']['#description'] .= theme('advanced_help_topic', array('module' => 'cforge', 'topic' => 'image'));

  $form['contact']['#access'] = FALSE;
  $form['timezone']['#access'] = FALSE;
  $form['profile_notes']['#access'] = user_access('committee');
}

/*
 * implemnts hook_form_FORM_ID_alter
 * adding context to the site-information page for local admins
 */
function cforge_form_system_site_information_settings_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['front_page']['#access'] = FALSE;
    $form['error_page']['#access'] = FALSE;
    debug($form);
  }
}

/*
 * implemnts hook_form_FORM_ID_alter
 */
function cforge_form_user_admin_settings_alter(&$form) {
  unset($form['registration_cancellation']['user_register']['#options'][1]);
  $form['registration_cancellation']['user_cancel_method']['#access'] = FALSE;

  $form['admin_role']['#access'] = FALSE;
  $form['contact']['#access'] = FALSE;
  $form['email_no_approval_required']['#access'] = FALSE;
  if ($GLOBALS['user']->uid != 1) {
    $form['registration_cancellation']['#description'] = $form['registration_cancellation']['user_email_verification']['#description'];
    $form['registration_cancellation']['user_email_verification'] = FALSE;
    $form['personalization']['#access'] = FALSE;
    $form['contact']['#access'] = FALSE;
    $form['admin_role']['#access'] = FALSE;
  }
}

/*
 * implemnts hook_form_FORM_ID_alter
 */
function cforge_form_node_form_alter(&$form, &$form_state) {

  //forces users to put pages in one of the four flattened menus, and other node types have no menus at all
  if ($form['#node']->type == 'page') {
    //prevent changing the alias of the home page
    if ($GLOBALS['user']->uid != 1) {
      if ($form['path']['alias']['#default_value'] == 'home') {
        $form['path']['#access'] = FALSE;
      }
    }
    $form['menu']['link']['parent']['#title'] = t('Put in menu');
    $options = db_query("SELECT CONCAT(menu_name,':0'), title FROM {menu_custom} WHERE menu_name IN ('main-menu', 'secondary-links', 'user-menu', 'visitors')")->fetchAllKeyed();
    $form['menu']['link']['parent']['#options'] = $options;

    drupal_add_css('.form-item-menu-enabled{display:none;}', array('type' => 'inline'));
    $form['menu']['enabled']['#default_value'] = TRUE;
    $form['menu']['link']['link_title']['#required'] = TRUE;
  }
  else {
    unset($form['menu']);
  }
  //puts the broadcast button in for certain node-types
  if (in_array($form['#node']->type, array('proposition', 'story', 'document', 'event' ))) {
    if (!$form['#node']->{NODE_BROADCAST_FLAG}) {
      $form['actions']['broadcast'] = array(
        '#type' => 'submit',
        '#value' => t('Save & mail everyone'),
        '#weight' => 10,
        '#submit' => array('node_broadcast_submit')
      );
    }
  }
  $form['options']['promote']['#access'] = FALSE;
  $form['options'][NODE_BROADCAST_FLAG]['#access'] = FALSE;
}

/*
 * implemnts hook_form_FORM_ID_alter
 */
function cforge_form_system_theme_settings_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['theme_settings']['#access'] = FALSE;
  }
}

/*
 * implemnts hook_form_FORM_ID_alter
 * simplify the taxonomy page
 */
function cforge_form_taxonomy_form_term_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['advanced']['#access'] = FALSE;
    debug($form['advanced']);
  }
}

/*
 * implemnts hook_form_FORM_ID_alter
 */
function cforge_form_search_block_form_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['search_block_form']['#title'] = '';
  }
}
function cforge_form_search_theme_form_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['search_block_form']['#title'] = '';
    debug($form['search_block_form']);
  }
}
/*
 * implemnts hook_form_FORM_ID_alter
 */
function cforge_form_user_login_alter(&$form) {
    if ($GLOBALS['user']->uid != 1) {
    $form['pass']['#title'] = t('Password');
    $form['name']['#size']=10;
    $form['pass']['#size']=10;
  }
}
function cforge_form_user_login_block_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['pass']['#title'] = t('Password');
    $form['name']['#size']=10;
    $form['pass']['#size']=10;
  }
}

function cforge_form_menu_edit_item_alter(&$form) {
  if ($GLOBALS['user']->uid != 1) {
    $form['menu']['#access'] = TRUE;
      debug($form);
  }
}

/*
 * additional submit handler for node form
 */
function node_broadcast_submit($form, $form_state) {
  $form_state['values']['sticky'] = 1;
  node_form_submit($form, $form_state);
  debug($form_state['nid']);
  global $language;
  $params = array('node' => $form_state['values']);
  drupal_mail('cforge', 'broadcast', variable_get('site_mail', 'blah'), $language->language, $params);
  
}

/*
 * implements hook_mail
 * for the broadcast function
 */
function cforge_mail($key, &$message, $params) {
  $mails = db_query("SELECT mail FROM {users} u
    LEFT JOIN {users_roles} ur ON u.uid = ur.uid
    WHERE ur.rid = ". RID_TRADER)->fetchCol();
  $sender = user_load($params['node']['uid']);
  $message['subject'] = t('@site_name: @node_title',
    array('@site_name' => variable_get('site_name', ''), '@node_title' => $params['node']['title'])
  );
  $message['body'][] = t('@name posted a new @type.', array(
    '@name' => $sender->name,
    '@type' => node_type_get_type($params['node']['type'])->name
  ));
  $message['body'][] = drupal_render(node_view((object)$params['node']));
  $message['headers']['From'] = $sender->mail;
  $message['headers']['Bcc'] = implode(', ', $mails);
}

/*
 * modified menu callback
 */
function cforge_user_autocomplete($string = '') {
  $matches = array();
  if ($string) {
    $result = db_query(
      "SELECT DISTINCT u.uid, u.name FROM {users} u
      LEFT JOIN {users_roles} ur ON u.uid = ur.uid
      WHERE u.status = 1 AND u.uid > 0 AND rid IN (".RID_TRADER.", ".RID_SYSTEM.") AND (
        LOWER(u.name) LIKE LOWER(:name)
        OR LOWER(u.mail) LIKE LOWER(:mail)
        OR u.uid LIKE (:uid)
      )",
      array(':name' => $string, ':mail' => $string, ':uid' => $string)
    );
    $traders = get_trader_list();
    while ($user = db_fetch_object($result)) {
      $matches[$user->name] = $traders[$user->uid];
    }
  }
  drupal_json(array_splice($matches, 0, 10));
}


/*
 * menu callback
 * shortcut to the backup & restore module download backup
 */
function backup_direct() {
  $tables = array('cache', 'cache_admin_menu', 'cache_block', 'cache_bootstrap', 'cache_field', 'cache_filter', 'cache_image', 'cache_menu', 'cache_page', 'cache_path', 'cache_update', 'cache_views', 'cache_views_data', 'watchdog');

  foreach($tables as $table) {
    $queries[] = "TRUNCATE {$table}";
  }
  db_query(implode(';', $queries));
  $form_state['values'] = array(
    'profile_id' => NULL,
    'destination_id' => 'download',
    'source_id' => NULL,
  );
  drupal_form_submit('backup_migrate_ui_manual_quick_backup_form', $form_state);
  drupal_goto(BACKUP_MIGRATE_MENU_PATH .'/restore');
}




//protect certain fields from being inadvertantly included in views
function ____cforge_views_pre_render(&$view) {
  if (user_access('access user profiles')) return;
  $private = array(
    'users_picture' => '',
    'users_mail' => variable_get('site_mail', 'blah'),
    'users_name' => ''
  );
  debug($view->result, "stripping users' pictures, mail and name from view $view->name");
  foreach ($private as $field => $value) {
    foreach ($view->result as $key=>$row) {
      $view->result[$key]->$field = $value;
    }
  }
}

