<?php


/**
 * Returns the rendered local tasks. The default implementation renders
 * them as tabs.
 *
 * @ingroup themeable
 */
function sky_seldulac_menu_local_tasks() {
  
  $primary = menu_primary_local_tasks();
  $secondary = menu_secondary_local_tasks();
  $output = '';
  if ($primary || $secondary) {
    if ($primary) {
      $output .= "\n".'<div class="tabs-primary">'."\n".
      '  <ul>'."\n". render($primary) .'</ul>'."\n".
      '</div>';
    }
    if ($secondary) {
      $output .= "\n".'<div class="tabs-secondary">'."\n" .
      '  <ul>'."\n". render($secondary) .'</ul>'."\n" .
      '</div>';
    }
    return '<div class="tab-wrapper">' . $output .'</div>';
  }
}
/*
 * theme implementations
 */
/*
 * implements theme hook_preprocess page
 * builds the custom menus into the regions
 */
function sky_seldulac_preprocess_page(&$vars) {
  $regions = array('secondary' => array('secondary-links'));
  if ($vars['logged_in']) $regions['navigation'][] = 'main_menu';
  if (!$vars['logged_in'] || isset($GLOBALS['user']->roles[4])) {//4 means RID_COMMITTEE, which isn't avaialble from here
    $regions['navigation'][] = 'visitors';
  }
  foreach ($regions as $region => $menus) {
    $render = array();
    foreach ($menus as $menu) {
      if (!isset($vars[$menu])) {
        $vars[$menu] = menu_navigation_links($menu);
      }
      $render[] = theme('links__system_'.$menu, array(
        'links' => $vars[$menu],
        'attributes' => array(
          'class' => array('links', 'inline', str_replace('_', '-', $menu)),
        )
      ));
    }
    $vars[$region] = implode('<br />', $render);
  }
}
